## ipu6-camera-hal 0~git202310160955.cb2befc~ubuntu22.04.6

=== src/CMakeLists.txt ===
#
#  Copyright (C) 2018-2019 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

add_subdirectory(3a)
add_subdirectory(core)
add_subdirectory(hal)
add_subdirectory(iutils)
add_subdirectory(scheduler)
add_subdirectory(metadata)
add_subdirectory(platformdata)
add_subdirectory(v4l2)
add_subdirectory(image_process)
if (CAL_BUILD)
    add_subdirectory(jpeg)
endif() #CAL_BUILD
if(FACE_DETECTION)
    add_subdirectory(fd)
endif() #FACE_DETECTION

=== src/iutils/CMakeLists.txt ===
#
#  Copyright (C) 2017-2021 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set(IUTILS_SRCS
    ${IUTILS_DIR}/CameraLog.cpp
    ${IUTILS_DIR}/LogSink.cpp
    ${IUTILS_DIR}/ModuleTags.cpp
    ${IUTILS_DIR}/CameraDump.cpp
    ${IUTILS_DIR}/Trace.cpp
    ${IUTILS_DIR}/ScopedAtrace.cpp
    ${IUTILS_DIR}/Thread.cpp
    ${IUTILS_DIR}/Utils.cpp
    ${IUTILS_DIR}/SwImageConverter.cpp
# SUPPORT_MULTI_PROCESS_S
    ${IUTILS_DIR}/CameraShm.cpp
# SUPPORT_MULTI_PROCESS_E
    CACHE INTERNAL "iutils sources"
    )

=== src/jpeg/CMakeLists.txt ===
#
#  Copyright (C) 2019 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

if (SW_JPEG_ENCODE)
    set(JPEG_SRCS
        ${JPEG_DIR}/sw/SWJpegEncoder.cpp
        CACHE INTERNAL "jpeg sources"
       )
else ()
    set(JPEG_SRCS
        ${JPEG_DIR}/chrome/JpegEncoderCore.cpp
        CACHE INTERNAL "jpeg sources"
        )
endif()

set(JPEG_SRCS
    ${JPEG_SRCS}
    ${JPEG_DIR}/ExifCreater.cpp
    ${JPEG_DIR}/EXIFMetaData.cpp
    ${JPEG_DIR}/EXIFMaker.cpp
    ${JPEG_DIR}/JpegMaker.cpp
    CACHE INTERNAL "jpeg sources"
    )

=== src/v4l2/CMakeLists.txt ===
#
#  Copyright (C) 2017,2020 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set (V4L2_SRCS
    ${V4L2_DIR}/MediaControl.cpp
    ${V4L2_DIR}/V4l2DeviceFactory.cpp
    ${V4L2_DIR}/SysCall.cpp
    ${V4L2_DIR}/NodeInfo.cpp
    CACHE INTERNAL "v4l2 sources"
    )

if (NOT CAL_BUILD)
    set(V4L2_SRCS
        ${V4L2_SRCS}
        ${MODULES_DIR}/v4l2/v4l2_device.cc
        ${MODULES_DIR}/v4l2/v4l2_subdevice.cc
        ${MODULES_DIR}/v4l2/v4l2_video_node.cc
        CACHE INTERNAL "v4l2 sources"
        )
endif()

=== src/hal/hal_adaptor/CMakeLists.txt ===
#
#  Copyright (C) 2023 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

cmake_minimum_required(VERSION 2.8)
project(hal_adaptor)

# Source directories
set(ROOT_DIR        ${CMAKE_CURRENT_LIST_DIR}/../../../)
set(METADATA_DIR    ${ROOT_DIR}/src/metadata)
set(IUTILS_DIR      ${ROOT_DIR}/src/iutils)
set(HAL_ADAPTOR_DIR ${ROOT_DIR}/src/hal/hal_adaptor)

include_directories(${ROOT_DIR}/include
                    ${ROOT_DIR}/include/api
                    ${ROOT_DIR}/include/utils
                    ${ROOT_DIR}/src/metadata
                    ${ROOT_DIR}/src/iutils
                    ${ROOT_DIR}/src/core
                    ${ROOT_DIR}/src/platformdata
                    ${ROOT_DIR}/src/isp_control
                    ${ROOT_DIR}/src
                    ${ROOT_DIR}/modules/v4l2
                    ${ROOT_DIR}
                    )

# Install directories
# CMAKE_INSTALL_PREFIX is defined when executing cmake.
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}" CACHE PATH "Target location for install command." FORCE)
endif()
message(STATUS "install prefix: " ${CMAKE_INSTALL_PREFIX})

include(GNUInstallDirs)

# Set the aligned flag
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-faligned-new COMPILER_SUPPORTS_ALIGNED_NEW)
if (COMPILER_SUPPORTS_ALIGNED_NEW)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -faligned-new")
endif()

# Set the CXX to 11
set (CMAKE_CXX_STANDARD 11)
add_compile_options(-Wall -Werror
                    -fstack-protector
                    -fPIE -fPIC
                    -D_FORTIFY_SOURCE=2
                    -DDCHECK_ALWAYS_ON
                    -Wformat -Wformat-security
                    )

add_definitions(-D__STDC_FORMAT_MACROS
                -DHAVE_PTHREADS
                -DHAVE_LINUX_OS
                -DCAMHAL_PLUGIN_DIR=\"${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/libcamhal/plugins/\"
                )

set(HAL_ADAPTOR_LD_FLAGS "-fPIE -fPIC -D_FORTIFY_SOURCE=2 -Wformat -Wformat-security -Wl,-z,relro -Wl,-z,now")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${HAL_ADAPTOR_LD_FLAGS}")

set(HAL_ADAPTOR_SRCS
    ${METADATA_DIR}/icamera_metadata_base.cpp
    ${METADATA_DIR}/CameraMetadata.cpp
    ${METADATA_DIR}/Parameters.cpp
    ${METADATA_DIR}/ParameterHelper.cpp
    ${IUTILS_DIR}/CameraLog.cpp
    ${IUTILS_DIR}/LogSink.cpp
    ${IUTILS_DIR}/ModuleTags.cpp
    ${IUTILS_DIR}/Trace.cpp
    ${IUTILS_DIR}/Utils.cpp
    ${IUTILS_DIR}/ScopedAtrace.cpp
    ${HAL_ADAPTOR_DIR}/HalAdaptor.cpp
    CACHE INTERNAL "hal adaptor sources"
)

add_library(hal_adaptor SHARED ${HAL_ADAPTOR_SRCS})
set_target_properties(hal_adaptor PROPERTIES OUTPUT_NAME camhal)
set_target_properties(hal_adaptor PROPERTIES SOVERSION 0)
set_target_properties(hal_adaptor PROPERTIES VERSION "0.0.0")

#---------------------------- Link settings ----------------------------
set (THREADS_PREFER_PTHREAD_FLAG ON)
find_package (Threads REQUIRED)
target_link_libraries(hal_adaptor ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries(hal_adaptor ${CMAKE_DL_LIBS})
target_link_libraries(hal_adaptor rt)

# Install headers
install(DIRECTORY ${ROOT_DIR}/include/ DESTINATION include/libcamhal)
if (SUPPORT_LIVE_TUNING)
    install(FILES ${ROOT_DIR}/modules/livetune/LiveTuning.h DESTINATION include/libcamhal/api)
endif()

# Install libraries
if (${CMAKE_VERSION} VERSION_LESS 3.11)
    install(TARGETS hal_adaptor
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            )
else()
    install(TARGETS hal_adaptor DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# Install package config file
configure_file(${PROJECT_SOURCE_DIR}/hal_adaptor.pc.cmakein
               ${PROJECT_SOURCE_DIR}/libcamhal.pc @ONLY)
install(FILES libcamhal.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

set(CPACK_GENERATOR "RPM")
include(CPack)

=== debian/changelog ===
ipu6-camera-hal (0~git202310160955.cb2befc~ubuntu22.04.6) jammy; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Tue, 24 Oct 2023 05:13:05 +0000

ipu6-camera-hal (0~git202309140950.f590252-1) UNRELEASED; urgency=medium

  [ Shih-Yuan Lee (FourDollars) ]
  * debian/control: Add tildes in the end of versions to support the usage by git-build-recipe.
  * debian: Fix the plugins path of libcamhal0

  [ jimlai ]
  * Port sensor files from IPU6EP to IPU6EPMTL
  * Update port number for MTL

  [ You-Sheng Yang ]
  * cmake: correct CAMERA_DEFAULT_CFG_PATH

  [ Shih-Yuan Lee (FourDollars) ]
  * debian: Drop 0004-cmake-correct-CAMERA_DEFAULT_CFG_PATH.patch.

 -- Shih-Yuan Lee (FourDollars) <sylee@canonical.com>  Thu, 14 Sep 2023 18:01:31 +0800

ipu6-camera-hal (0~git202309010954.7964af4-1) UNRELEASED; urgency=medium

  [ Shih-Yuan Lee ]
  * Use a matrix for build tests.
  * Set 10 minutes timeout for build tests and avoid the ubuntu:20.04 halt
    issue on GitHub Actions.

  [ Kai-Chuan Hsieh ]
  * Support hm2170 sensor on port 2

  [ You-Sheng Yang ]
  * Conform to Debian packging policy
    - dfsg: cmake: specify library version
    - dfsg: cmake: link to corresponding libs
    - dfsg: cmake: drop the use of CMAKE_INSTALL_SUB_PATH
    - dfsg: cmake: turn hal adapter into libcamhal entrypoint
    - dfsg: build: drop redundant lib files manipulation
    - dfsg: ci: fix test cases
    - dfsg: cmake: correct plugin path
    - dfsg: hal: lower library name printing loudness

  [ You-Sheng Yang ]
  * debian: refresh patches
  * debian: update packaging files

 -- You-Sheng Yang <vicamo.yang@canonical.com>  Fri, 01 Sep 2023 18:12:49 +0800

ipu6-camera-hal (0~git202308100916.249d07e-1) UNRELEASED; urgency=medium

  * Intel 20230802_1500_mtl_plat release.

  [ You-Sheng Yang ]

  * debian: refresh patches
  * debian: update packaging files

 -- You-Sheng Yang <vicamo.yang@canonical.com>  Mon, 21 Aug 2023 22:35:27 +0800

=== debian/control ===
Source: ipu6-camera-hal
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 libexpat-dev,
 libipu6-dev (>= 0~git202309010954.376fccf~),
 libipu6ep-dev (>= 0~git202309010954.376fccf~),
 libipu6epmtl-dev (>= 0~git202309010954.376fccf~),
 pkg-config,
 dh-modaliases,
Standards-Version: 4.5.0
Maintainer: Commercial Engineering <commercial-engineering@canonical.com>
Vcs-Browser: https://github.com/intel/ipu6-camera-hal
Vcs-Git: https://github.com/intel/ipu6-camera-hal.git

Package: libcamhal-common
Architecture: all
Depends:
 ${misc:Depends},
Breaks:
 libcamhal-ipu6ep-common (<= 0~git202309010954.7964af4~),
Replaces:
 libcamhal-ipu6ep-common (<= 0~git202309010954.7964af4~),
Description: HAL library for MIPI camera through Intel IPU6 - common files
 This package contains default camera settings on Intel Tiger Lake platform.

Package: libcamhal0
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal-common (= ${source:Version}),
Breaks:
 libcamhal-ipu6ep0 (<= 0~git202309010954.7964af4~),
Replaces:
 libcamhal-ipu6ep0 (<= 0~git202309010954.7964af4~),
Recommends:
 gstreamer1.0-icamera, v4l2-relayd
XB-Modaliases: ${modaliases}
Description: HAL library for MIPI camera through Intel IPU6
 This package contains the main runtime library on Intel Tiger Lake platform.

Package: libcamhal-dev
Architecture: any
Depends:
 ${misc:Depends},
 libcamhal0 (= ${binary:Version}),
 pkg-config,
Breaks:
 libcamhal-ipu6ep-dev (<= 0~git202309010954.7964af4~),
Replaces:
 libcamhal-ipu6ep-dev (<= 0~git202309010954.7964af4~),
Description: HAL library for MIPI camera through Intel IPU6 - development kit
 This package contains development files for libcamhal0 on Intel Tiger Lake
 platform.

Package: libcamhal-ipu6ep-common
Architecture: all
Depends: libcamhal-common
Description: Transitional package for libcamhal-common
 This is a transitional package for libcamhal-common, and can be
 safely removed after the installation is complete.

Package: libcamhal-ipu6ep-dev
Architecture: any
Depends: libcamhal-dev
Description: Transitional package for libcamhal-dev
 This is a transitional package for libcamhal-dev, and can be
 safely removed after the installation is complete.

Package: libcamhal-ipu6ep0
Architecture: any
Depends: libcamhal0
Description: Tansitional package for libcamhal0
 This is a transitional package for libcamhal0, and can be
 safely removed after the installation is complete.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

configure_args = \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_CAMHAL_TESTS=OFF \
	-DUSE_PG_LITE_PIPE=ON \
	-DUSE_HAL_ADAPTOR=ON \
	$(empty)

targets = ipu6 ipu6ep ipu6epmtl

%:
	dh $@ --with modaliases

override_dh_auto_configure:
	for ipu_ver in $(targets); do \
	  dh_auto_configure --builddirectory=build/$${ipu_ver} -- \
	      -DIPU_VER=$${ipu_ver} $(configure_args); \
	done
	dh_auto_configure --sourcedirectory=src/hal/hal_adaptor --builddirectory=build/hal

override_dh_auto_build:
	for ipu_ver in $(targets); do \
	  dh_auto_build --builddirectory=build/$${ipu_ver}; \
	done
	dh_auto_build --builddirectory=build/hal

override_dh_auto_install:
	sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
	    debian/libcamhal0.install.in > debian/libcamhal0.install
	sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
	    debian/libcamhal-dev.install.in > debian/libcamhal-dev.install
	for ipu_ver in $(targets); do \
	  dh_auto_install --builddirectory=build/$${ipu_ver} --destdir=debian/tmp; \
	done
	dh_auto_install --builddirectory=build/hal --destdir=debian/tmp

override_dh_auto_clean:
	for ipu_ver in $(targets); do \
	  dh_auto_clean --builddirectory=build/$${ipu_ver}; \
	done
	dh_auto_clean --builddirectory=build/hal
	rm -rf debian/tmp

## ipu6-camera-hal 0~git202312190139.46efbcb~ubuntu22.04.1

=== CMakeLists.txt ===
#
#  Copyright (C) 2017-2023 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

cmake_minimum_required(VERSION 2.8)

project(libcamhal)


#---------------------------- Fold settings ----------------------------

# Source directories
set(SRC_ROOT_DIR        ${CMAKE_CURRENT_LIST_DIR}/src)

set(3A_DIR              ${SRC_ROOT_DIR}/3a)
set(CORE_DIR            ${SRC_ROOT_DIR}/core)
set(HAL_DIR             ${SRC_ROOT_DIR}/hal)
set(IIO_DIR             ${SRC_ROOT_DIR}/iio)
set(IUTILS_DIR          ${SRC_ROOT_DIR}/iutils)
set(SCHEDULER_DIR       ${SRC_ROOT_DIR}/scheduler)
set(METADATA_DIR        ${SRC_ROOT_DIR}/metadata)
set(PLATFORMDATA_DIR    ${SRC_ROOT_DIR}/platformdata)
set(V4L2_DIR            ${SRC_ROOT_DIR}/v4l2)
set(MODULES_DIR         ${CMAKE_CURRENT_LIST_DIR}/modules)
set(ALGOWRAPPER_DIR     ${MODULES_DIR}/algowrapper)
set(SANDBOXING_DIR      ${MODULES_DIR}/sandboxing)
set(IMAGE_PROCESS_DIR   ${SRC_ROOT_DIR}/image_process)

#AAL directories
if (CAL_BUILD)
    set(AAL_ROOT_DIR       ${CMAKE_CURRENT_LIST_DIR}/aal)
    set(JPEG_DIR           ${SRC_ROOT_DIR}/jpeg)
    set(MEMORY_DIR         ${MODULES_DIR}/memory)
endif() #CAL_BUILD

if (SUPPORT_LIVE_TUNING)
    #LiveTuning directories
    set(LIVE_TUNING_DIR         ${MODULES_DIR}/livetune)
endif() #SUPPORT_LIVE_TUNING

# ia_cipr is only used by psysprocessor
if (USE_PG_LITE_PIPE)
set(IA_CIPR_DIR         ${MODULES_DIR}/ia_cipr)
set(MODULE_IA_CSS_DIR   ${MODULES_DIR}/ia_css)
endif() #USE_PG_LITE_PIPE

# CMake module directory
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

# Install directories
# CMAKE_INSTALL_PREFIX is defined when executing cmake and supposed to be ./out/libcamhal
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}" CACHE PATH "Target location for install command." FORCE)
endif()

message(STATUS "install prefix: " ${CMAKE_INSTALL_PREFIX})

#------------------------- Compilation settings -------------------------

include(GNUInstallDirs)

# -fPIC in xos way
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-faligned-new COMPILER_SUPPORTS_ALIGNED_NEW)
if (COMPILER_SUPPORTS_ALIGNED_NEW)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -faligned-new")
endif()

set (CMAKE_CXX_STANDARD 11)
add_compile_options(-Wall -Werror
                    -fstack-protector
                    -fPIE -fPIC
                    -D_FORTIFY_SOURCE=2
                    -DDCHECK_ALWAYS_ON
                    -Wformat -Wformat-security
                    )
# code coverage.
include(code-coverage)

add_definitions(-D__STDC_FORMAT_MACROS
                -DHAVE_PTHREADS
                -DHAVE_LINUX_OS
                -DHAVE_IA_TYPES
                -DHAVE_PRCTL
                )

if (USE_PG_LITE_PIPE)
        add_definitions(-DUSE_PG_LITE_PIPE)
endif() #USE_PG_LITE_PIPE

if (CAL_BUILD)
    message("Chrome enabled ")
    add_definitions(-DCAL_BUILD)
    add_definitions(-DDUMP_IMAGE)
else()
    add_definitions(-DSUPPORT_MULTI_PROCESS)
    add_definitions(-DLINUX_BUILD)
endif() #CAL_BUILD

if (FACE_DETECTION)
    add_definitions(-DFACE_DETECTION)
endif() #FACE_DETECTION

# IPU6_FEATURE_S
if (IPU_VER MATCHES "ipu6")
    add_definitions(-DIPU_SYSVER_IPU6)
endif()
# IPU6_FEATURE_E

# IPU6_SE_FEATURE_S
if ("${IPU_VER}" STREQUAL "ipu6sepla")
    add_definitions(-DIPU_SYSVER_ipu6v3)
endif()
# IPU6_SE_FEATURE_E

if ("${IPU_VER}" STREQUAL "ipu6ep")
    message(INFO "add definition -DIPU_SYSVER_ipu6v5 for ipu6ep")
    add_definitions(-DIPU_SYSVER_ipu6v5)
endif()

if ("${IPU_VER}" STREQUAL "ipu6epmtl")
    message(INFO "add definition -DIPU_SYSVER_ipu6v6 for ipu6ep")
    add_definitions(-DIPU_SYSVER_ipu6v6)
endif()

include_directories(include
                    include/api include/utils
                    ${CMAKE_INSTALL_PREFIX}/include/ia_camera
                    ${CMAKE_INSTALL_PREFIX}/include/
                    ${CMAKE_CURRENT_LIST_DIR}
                    src
                    src/v4l2 src/core src/metadata
                    src/platformdata src/platformdata/gc
                    src/3a src/3a/intel3a src/3a/external
                    src/fd src/scheduler
                    src/core/psysprocessor
                    src/image_process
                    )

set(LIBCAMHAL_LD_FLAGS "-fPIE -fPIC -D_FORTIFY_SOURCE=2 -Wformat -Wformat-security -Wl,-z,relro -Wl,-z,now")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${LIBCAMHAL_LD_FLAGS}")

add_subdirectory(src)
add_subdirectory(modules)

# Set source files
if (CAL_BUILD)
    if (SW_JPEG_ENCODE)
        add_definitions(-DSW_JPEG_ENCODE)
        include_directories(src/jpeg/sw)
    else ()
        include_directories(src/jpeg/chrome)
    endif()

    if (SW_POST_PROCESSING)
        include_directories(src/image_process/sw)
    else ()
        include_directories(src/image_process/chrome)
    endif()

    add_subdirectory(aal)

    set(LIBCAMHAL_SRCS
        ${LIBCAMHAL_SRCS}
        ${MEMORY_SRCS}
        ${AAL_SRCS}
        ${JPEG_SRCS}
        )
    include_directories(include include/api include/utils include/linux
                        ${USR_INCLUDE_HEADER}/android/system/core/include/
                        ${USR_INCLUDE_HEADER}/ia_imaging
                        ${USR_INCLUDE_HEADER}/lib${IPU_VER}
                        ${USR_INCLUDE_HEADER}/android/hardware/libhardware/include/
                        aal aal/chrome src/iutils src/jpeg
                        modules/memory modules/memory/chrome
                        )
endif() #CAL_BUILD

if (SUPPORT_LIVE_TUNING)
    set(LIBCAMHAL_SRCS ${LIVE_TUNING_SRCS})
    include_directories(modules/livetune)
endif() #SUPPORT_LIVE_TUNING

if (USE_PG_LITE_PIPE)
add_subdirectory(${MODULE_IA_CSS_DIR})
include_directories(${MODULE_IA_CSS_HEADER_INCLUDE_DIR})
set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${MODULE_IA_CSS_SRC})

# suppress modules/ia_css .c code compiling error
include(CheckCCompilerFlag)
CHECK_C_COMPILER_FLAG("-Wno-error=unused-but-set-variable" COMPILER_SUPPORTS_NO_UNUSED_BUT_SET_VAR)
if (COMPILER_SUPPORTS_NO_UNUSED_BUT_SET_VAR)
    set_source_files_properties(${MODULE_IA_CSS_SRC} PROPERTIES COMPILE_FLAGS
                                "-Wno-error=unused-but-set-variable ${CMAKE_C_FLAGS}")
endif()
endif() #USE_PG_LITE_PIPE

set(LIBCAMHAL_SRCS
    ${LIBCAMHAL_SRCS}
    ${3A_SRCS}
    ${CORE_SRCS}
    ${HAL_SRCS}
    ${IPS_CTRL_SRCS}
    ${IUTILS_SRCS}
    ${METADATA_SRCS}
    ${PLATFORMDATA_SRCS}
    ${SCHEDULER_SRCS}
    ${V4L2_SRCS}
    ${ALGOWRAPPER_SRCS}
    ${IMAGE_PROCESS_SRCS}
    ${MODULES_DIR}/ia_cipr/src/Buffer.cpp
    ${MODULES_DIR}/ia_cipr/src/Context.cpp
    ${MODULES_DIR}/ia_cipr/src/Event.cpp
    ${MODULES_DIR}/ia_cipr/src/Command.cpp
    ${MODULES_DIR}/ia_cipr/src/Utils.cpp
    )

if(FACE_DETECTION)
set(LIBCAMHAL_SRCS
    ${LIBCAMHAL_SRCS}
    ${FACE_DETECTION_SRCS}
    )
endif() #FACE_DETECTION

if(ENABLE_SANDBOXING)
set(LIBCAMHAL_SRCS
    ${LIBCAMHAL_SRCS}
    ${SANDBOXING_CLIENT_SRCS}
    )
endif() #ENABLE_SANDBOXING

    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${IIO_SRCS})

# Add libcamhal using the specified sources
if (${CMAKE_VERSION} VERSION_LESS 3.11)
    add_library(camhal SHARED ${LIBCAMHAL_SRCS})
else()
    add_library(camhal SHARED $<TARGET_OBJECTS:camhal_static>)
endif()
if(NOT USE_HAL_ADAPTOR)
    set_target_properties(camhal PROPERTIES SOVERSION 0)
    set_target_properties(camhal PROPERTIES VERSION "0.0.0")
endif()

add_library(camhal_static STATIC ${LIBCAMHAL_SRCS})

if(NOT DEFINED IPU_VER)
    set(CAMHAL_NAME_SUFFIX "-ipu4")
elseif(${IPU_VER} STREQUAL ipu6)
    set(CAMHAL_NAME_SUFFIX "")
else()
    set(CAMHAL_NAME_SUFFIX "-${IPU_VER}")
endif()
set_target_properties(camhal_static PROPERTIES OUTPUT_NAME camhal${CAMHAL_NAME_SUFFIX})

#---------------------------- Link settings ----------------------------
target_link_libraries(camhal ${CMAKE_DL_LIBS})
target_link_libraries(camhal_static ${CMAKE_DL_LIBS})

set (THREADS_PREFER_PTHREAD_FLAG ON)
find_package (Threads REQUIRED)
target_link_libraries(camhal ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries(camhal_static ${CMAKE_THREAD_LIBS_INIT})

target_link_libraries(camhal expat rt)
target_link_libraries(camhal_static expat rt)

if (CAL_BUILD)
    target_link_libraries(camhal camera_v4l2_device)
    target_link_libraries(camhal_static camera_v4l2_device)
endif()

# Link libraries, the building will be interrupted if libs/includes not found

    # Link ia_imaging
    find_package(IA_IMAGING)
    include_directories(${IA_IMAGING_INCLUDE_DIRS})
    target_link_libraries(camhal ${IA_IMAGING_LIBS})
    target_link_libraries(camhal_static ${IA_IMAGING_LIBS})

if(USE_PG_LITE_PIPE)
    find_package(LIBGCSS)
    include_directories(${LIBGCSS_INCLUDE_DIRS})
    target_link_libraries(camhal ${LIBGCSS_LIBS})
    target_link_libraries(camhal_static ${LIBGCSS_LIBS})
else()
    # Link libiacss
    find_package(LIBIACSS)
    include_directories(${LIBIACSS_INCLUDE_DIRS})
    target_link_libraries(camhal ${LIBIACSS_LIBS})
    target_link_libraries(camhal_static ${LIBIACSS_LIBS})
endif()

# Include libipu(4) headers
find_package(LIBIPU)
include_directories(${LIBIPU_INCLUDE_DIRS})

if (USE_PG_LITE_PIPE)
    target_link_libraries(camhal ${IPU_LIB})
    target_link_libraries(camhal_static ${IPU_LIB})
endif()

if (CAL_BUILD)
    find_package(LIBCAMERA_CLIENT)
    find_package(LIBCAMERA_COMMON)
    find_package(LIBCAMERA_METADATA)
    find_package(LIBCAMERA_V4L2_DEVICE)
    find_package(LIBSYNC)
    find_package(LIBCBM)

    include_directories(${LIBCAMERA_CLIENT_INCLUDE_DIRS} ${LIBCAMERA_COMMON_INCLUDE_DIRS}
                        ${LIBCAMERA_METADATA_INCLUDE_DIRS} ${LIBCAMERA_V4L2_DEVICE_INCLUDE_DIRS}
                        ${LIBSYNC_INCLUDE_DIRS}
                        ${LIBCBM_INCLUDE_DIRS}
                        )
    link_directories(${CMAKE_PREFIX_PATH} ${LIBCAMERA_CLIENT_LIBS} ${LIBCAMERA_METADATA_LIBS}
                     ${LIBCAMERA_COMMON_LIBS} ${LIBSYNC_LIBS}
                     ${LIBCBM_LIBS}
                     )

    target_link_libraries(camhal ${LIBCAMERA_CLIENT_LIBS} ${LIBCAMERA_COMMON_LIBS}
                          ${LIBCAMERA_METADATA_LIBS} ${LIBCAMERA_V4L2_DEVICE_LIBS}
                          ${LIBSYNC_LIBS} jpeg ${CMAKE_PREFIX_PATH}/libyuv.pic.a
                          ${LIBCBM_LIBS}
                          )
    target_link_libraries(camhal_static ${LIBCAMERA_CLIENT_LIBS} ${LIBCAMERA_COMMON_LIBS}
                          ${LIBCAMERA_METADATA_LIBS} ${LIBCAMERA_V4L2_DEVICE_LIBS}
                          ${LIBSYNC_LIBS} jpeg ${CMAKE_PREFIX_PATH}/libyuv.pic.a
                          ${LIBCBM_LIBS}
                          )
endif() #CAL_BUILD

if (NOT CAL_BUILD)
    include_directories(${MODULES_DIR}/v4l2)
endif()

if (FACE_DETECTION)
    target_link_libraries(camhal pvl_eye_detection pvl_face_detection pvl_mouth_detection)
    target_link_libraries(camhal_static pvl_eye_detection pvl_face_detection pvl_mouth_detection)
    target_link_libraries(camhal ${WORK_DIR_TMP}/src/fd/libface_detection.a)
    target_link_libraries(camhal_static ${WORK_DIR_TMP}/src/fd/libface_detection.a)
endif()

if (ENABLE_SANDBOXING)
    add_definitions(-DENABLE_SANDBOXING)

    find_package(LIBMOJO)
    find_package(LIBCAMERA_IPC)
    find_package(LIBCAB)

    include_directories(${USR_INCLUDE_HEADER}/base-${BASEVER})
    include_directories(${LIBMOJO_INCLUDE_DIRS})
    include_directories(${LIBCAMERA_IPC_INCLUDE_DIRS})

=== debian/changelog ===
ipu6-camera-hal (0~git202312190139.46efbcb~ubuntu22.04.1) jammy; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Wed, 20 Dec 2023 08:40:30 +0000

## ipu6-camera-hal 0~git202406210224.cb00bdd~ubuntu22.04.1

=== modules/algowrapper/CMakeLists.txt ===
#
#  Copyright (C) 2019-2021 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#
#

set(ALGOWRAPPER_SRCS
    ${ALGOWRAPPER_DIR}/IntelCca.cpp
    ${ALGOWRAPPER_DIR}/graph/GraphConfigImpl.cpp
    ${ALGOWRAPPER_DIR}/graph/GraphConfigPipe.cpp
    CACHE INTERNAL "algo wrapper sources"
    )

if (USE_PG_LITE_PIPE)
    set(ALGOWRAPPER_SRCS
        ${ALGOWRAPPER_SRCS}
        ${ALGOWRAPPER_DIR}/IntelPGParam.cpp
        CACHE INTERNAL "algo wrapper sources" )
endif() #USE_PG_LITE_PIPE

=== modules/memory/CMakeLists.txt ===
#
#  Copyright (C) 2019 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#
#

set(MEMORY_SRCS
    ${MEMORY_DIR}/chrome/Camera3Buffer.cpp
    ${MEMORY_DIR}/Camera3BufferPool.cpp
    CACHE INTERNAL "Memory sources"
    )

=== src/core/CMakeLists.txt ===
#
#  Copyright (C) 2017-2023 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set(CORE_SRCS
    ${CORE_DIR}/CaptureUnit.cpp
    ${CORE_DIR}/DeviceBase.cpp
    ${CORE_DIR}/CameraStream.cpp
    ${CORE_DIR}/CameraDevice.cpp
    ${CORE_DIR}/ProcessorManager.cpp
    ${CORE_DIR}/RequestThread.cpp
    ${CORE_DIR}/SwImageProcessor.cpp
    ${CORE_DIR}/BufferQueue.cpp
    ${CORE_DIR}/CameraBuffer.cpp
    ${CORE_DIR}/CameraEvent.cpp
    ${CORE_DIR}/LensHw.cpp
    ${CORE_DIR}/SensorHwCtrl.cpp
    ${CORE_DIR}/SofSource.cpp
    CACHE INTERNAL "core sources"
    )

# FRAME_SYNC_S
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/SyncManager.cpp
        CACHE INTERNAL "core sources"
        )
# FRAME_SYNC_E

# CSI_META_S
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/CsiMetaDevice.cpp
        CACHE INTERNAL "core sources"
        )
# CSI_META_E

# FILE_SOURCE_S
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/FileSource.cpp
        CACHE INTERNAL "core sources"
        )
# FILE_SOURCE_E

    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/psysprocessor/PolicyManager.cpp
        CACHE INTERNAL "core sources"
        )
# PRIVACY_MODE_S
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/CvfPrivacyChecker.cpp
        CACHE INTERNAL "core sources"
        )
# PRIVACY_MODE_E

# IPU_PROCESSING_S
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/PSysProcessor.cpp
        ${CORE_DIR}/IspParamAdaptor.cpp
        ${CORE_DIR}/psysprocessor/PSysDAG.cpp
        CACHE INTERNAL "core sources"
       )

if (USE_PG_LITE_PIPE)
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/psysprocessor/PipeLiteExecutor.cpp
        ${CORE_DIR}/psysprocessor/PGCommon.cpp
        ${CORE_DIR}/psysprocessor/PGUtils.cpp
        ${CORE_DIR}/psysprocessor/ShareReferBufferPool.cpp
        CACHE INTERNAL "core sources"
       )
else()
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/psysprocessor/PipeExecutor.cpp
        ${CORE_DIR}/psysprocessor/PSysPipe.cpp
        CACHE INTERNAL "core sources"
       )
endif()
# IPU_PROCESSING_E

=== src/fd/CMakeLists.txt ===
#
#  Copyright (C) 2019-2020 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#
#

# Use -DFACE_DETECTION to enable the face detection feature
if (NOT ENABLE_SANDBOXING)
    set(FACE_DETECTION_SRCS
        ${SRC_ROOT_DIR}/fd/FaceDetection.cpp
        ${ALGOWRAPPER_DIR}/IntelFaceDetection.cpp
        CACHE INTERNAL "Face detect sources"
        )
#---------------------------- include the header ----------------------------
    include_directories(${USR_INCLUDE_HEADER}/ia_imaging
                        ${ALGOWRAPPER_DIR}/IntelFaceDetection.h
                        ${IUTILS_DIR}
                        include/utils)
#---------------------------- static library ----------------------------
    add_library(face_detection STATIC ${FACE_DETECTION_SRCS})
else ()
    set(FACE_DETECTION_SRCS
        ${SRC_ROOT_DIR}/fd/FaceDetection.cpp
        CACHE INTERNAL "Face detect sources"
        )
endif()

if (CAL_BUILD)
    find_package(LIBCAMERA_V4L2_DEVICE)
    include_directories(${LIBCAMERA_V42L_DEVICE_INCLUDE_DIRS})
else()
    include_directories(${MODULES_DIR}/v4l2)
endif()

=== src/image_process/CMakeLists.txt ===
#
#  Copyright (C) 2019-2020 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

set(IMAGE_PROCESS_SRCS
    ${IMAGE_PROCESS_DIR}/ImageConverter.cpp
    ${IMAGE_PROCESS_DIR}/ImageScalerCore.cpp
    CACHE INTERNAL "image_process sources"
    )

if (CAL_BUILD)
set(IMAGE_PROCESS_SRCS
    ${IMAGE_PROCESS_DIR}/PostProcessorBase.cpp
    ${IMAGE_PROCESS_DIR}/PostProcessorCore.cpp
    CACHE INTERNAL "image_process sources"
    )
if (SW_POST_PROCESSING)
    set(IMAGE_PROCESS_SRCS
        ${IMAGE_PROCESS_SRCS}
        ${IMAGE_PROCESS_DIR}/sw/SWPostProcessor.cpp
        CACHE INTERNAL "image_process sources"
       )
else()
    set(IMAGE_PROCESS_SRCS
        ${IMAGE_PROCESS_SRCS}
        ${IMAGE_PROCESS_DIR}/chrome/ImageProcessorCore.cpp
        CACHE INTERNAL "image_process sources"
        )
endif() #SW_POST_PROCESSING
endif() #CAL_BUILD

=== src/platformdata/CMakeLists.txt ===
#
#  Copyright (C) 2017-2021 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set(PLATFORMDATA_SRCS
    ${PLATFORMDATA_DIR}/ParserBase.cpp
    ${PLATFORMDATA_DIR}/PlatformData.cpp
    ${PLATFORMDATA_DIR}/CameraParser.cpp
    ${PLATFORMDATA_DIR}/PolicyParser.cpp
    CACHE INTERNAL "platformdata sources"
   )

    set(PLATFORMDATA_SRCS
        ${PLATFORMDATA_SRCS}
        ${PLATFORMDATA_DIR}/AiqInitData.cpp
        ${PLATFORMDATA_DIR}/gc/GraphUtils.cpp
        ${PLATFORMDATA_DIR}/gc/GraphConfigManager.cpp
        ${PLATFORMDATA_DIR}/gc/GraphConfig.cpp
        CACHE INTERNAL "platformdata sources"
        )

=== src/hal/hal_adaptor/CMakeLists.txt ===
--- 
+++ 
@@ -58,7 +58,6 @@
 add_compile_options(-Wall -Werror
                     -fstack-protector
                     -fPIE -fPIC
-                    -D_FORTIFY_SOURCE=2
                     -DDCHECK_ALWAYS_ON
                     -Wformat -Wformat-security
                     )
@@ -69,7 +68,7 @@
                 -DCAMHAL_PLUGIN_DIR=\"${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/libcamhal/plugins/\"
                 )
 
-set(HAL_ADAPTOR_LD_FLAGS "-fPIE -fPIC -D_FORTIFY_SOURCE=2 -Wformat -Wformat-security -Wl,-z,relro -Wl,-z,now")
+set(HAL_ADAPTOR_LD_FLAGS "-fPIE -fPIC -Wformat -Wformat-security -Wl,-z,relro -Wl,-z,now")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${HAL_ADAPTOR_LD_FLAGS}")
 
 set(HAL_ADAPTOR_SRCS

=== debian/changelog ===
ipu6-camera-hal (0~git202406210224.cb00bdd~ubuntu22.04.1) jammy; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Fri, 21 Jun 2024 03:15:25 +0000

=== debian/control ===
--- 
+++ 
@@ -73,6 +73,6 @@
 Package: libcamhal-ipu6ep0
 Architecture: any
 Depends: libcamhal0
-Description: Tansitional package for libcamhal0
+Description: Transitional package for libcamhal0
  This is a transitional package for libcamhal0, and can be
  safely removed after the installation is complete.

## ipu6-camera-hal 0~git202410220058.74ffeab~ubuntu22.04.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -84,7 +84,6 @@
 add_compile_options(-Wall -Werror
                     -fstack-protector
                     -fPIE -fPIC
-                    -D_FORTIFY_SOURCE=2
                     -DDCHECK_ALWAYS_ON
                     -Wformat -Wformat-security
                     )
@@ -151,7 +150,7 @@
                     src/image_process
                     )
 
-set(LIBCAMHAL_LD_FLAGS "-fPIE -fPIC -D_FORTIFY_SOURCE=2 -Wformat -Wformat-security -Wl,-z,relro -Wl,-z,now")
+set(LIBCAMHAL_LD_FLAGS "-fPIE -fPIC -Wformat -Wformat-security -Wl,-z,relro -Wl,-z,now")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${LIBCAMHAL_LD_FLAGS}")
 
 add_subdirectory(src)
@@ -365,3 +364,6 @@
     include_directories(${USR_INCLUDE_HEADER}/base-${BASEVER})
     include_directories(${LIBMOJO_INCLUDE_DIRS})
     include_directories(${LIBCAMERA_IPC_INCLUDE_DIRS})
+    include_directories(${LIBCAB_INCLUDE_DIRS})
+
+    link_directories(${CMAKE_PREFIX_PATH}

=== debian/changelog ===
ipu6-camera-hal (0~git202410220058.74ffeab~ubuntu22.04.2) jammy; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Tue, 22 Oct 2024 04:27:27 +0000

## ipu6-camera-hal 0~git202410220058.74ffeab~ubuntu24.04.2

=== debian/changelog ===
ipu6-camera-hal (0~git202410220058.74ffeab~ubuntu24.04.2) noble; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Tue, 22 Oct 2024 04:32:58 +0000
